// GraphicEffects.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    return TRUE;
}



////////////////////////////////////////////////////////////////////////////////////
extern "C" __declspec(dllexport) int BitmapDataRotateHue(unsigned int tnBitmapDataWidth, 
														 unsigned int tnBitmapDataHeight, 
														 unsigned int tnBitmapDataScan0,
														 unsigned int tnBitmapDataStride,
														 unsigned int tnHue)
{
	unsigned char lcRed, lcGreen, lcBlue;

	int lnStride = tnBitmapDataStride;
	BYTE *lnPosition = (BYTE *)((void *)tnBitmapDataScan0);
	int lnWidth = tnBitmapDataWidth;
	int lnHeight = tnBitmapDataHeight;
	int lnOffset = lnStride - lnWidth*3;    // bytes to skip at end of each row

	for(int lnCounter2=0; lnCounter2 < lnHeight; lnCounter2++) 
	{
		for(int lnCounter1=0; lnCounter1 < lnWidth; ++lnCounter1 )
		{
			lcBlue  = lnPosition[0];
			lcGreen = lnPosition[1];
			lcRed   = lnPosition[2];
         
		//////////////////////////////////////////////////////////////
		unsigned char lcMinVal = min(lcRed, min(lcGreen, lcBlue));
		unsigned char lcMaxVal = max(lcRed, max(lcGreen, lcBlue));
		float lnDiff  = float(lcMaxVal) - float(lcMinVal);
		float lnSum   = float(lcMaxVal) + float(lcMinVal);
   
		float lnLuminance = lnSum / 510.0f;
		float lnSaturation, lnHue;
   
		if (lcMaxVal == lcMinVal) 
		{
			lnSaturation = 0.0f;
			lnHue = 0.0f;
		}
		else
		{ 
			float lnRedNorm = (lcMaxVal - lcRed) / lnDiff;      
			float lnGreenNorm = (lcMaxVal - lcGreen) / lnDiff;
			float lnBlueNorm = (lcMaxVal - lcBlue) / lnDiff;   

			lnSaturation = (lnLuminance <= 0.5f) ? (lnDiff / lnSum) : (lnDiff / (510.0f - lnSum));

			if (lcRed == lcMaxVal) lnHue = 60.0f * (6.0f + lnBlueNorm - lnGreenNorm);
			if (lcGreen == lcMaxVal) lnHue = 60.0f * (2.0f + lnRedNorm - lnBlueNorm);
			if (lcBlue  == lcMaxVal) lnHue = 60.0f * (4.0f + lnGreenNorm - lnRedNorm);
			if (lnHue > 360.0f) lnHue = lnHue - 360.0f;
		}
    
		lnHue = lnHue + tnHue;
		if (lnHue > 360.0f) lnHue -= 360.0f;
		else if (lnHue < 0.0f) lnHue += 360.0f;

		if (lnSaturation == 0.0) 
		{
			lcRed = lcGreen = lcBlue = unsigned char(lnLuminance * 255.0);
		}
		else
		{
			float lnRm1, lnRm2;
			if (lnLuminance <= 0.5f) lnRm2 = lnLuminance + lnLuminance * lnSaturation;  
			else                     lnRm2 = lnLuminance + lnSaturation - lnLuminance * lnSaturation;
									 lnRm1 = 2.0f * lnLuminance - lnRm2;   
			float lnRm11, lnRm12, lnRm13, lnRm21, lnRm22, lnRm23, lnRHue1, lnRHue2, lnRHue3;
			lnRm11 = lnRm12 = lnRm13 = lnRm1;
			lnRm21 = lnRm22 = lnRm23 = lnRm2;
			lnRHue1 = lnHue + 120.f;
			lnRHue2 = lnHue;
			lnRHue3 = lnHue - 120.f;

			if      (lnRHue1 > 360.0f) lnRHue1 -= 360.0f;
			else if (lnRHue1 <   0.0f) lnRHue1 += 360.0f;
			if      (lnRHue2 > 360.0f) lnRHue2 -= 360.0f;
			else if (lnRHue2 <   0.0f) lnRHue2 += 360.0f;
			if      (lnRHue3 > 360.0f) lnRHue3 -= 360.0f;
			else if (lnRHue3 <   0.0f) lnRHue3 += 360.0f;

			if      (lnRHue1 <  60.0f) lnRm11 = lnRm11 + (lnRm21 - lnRm11) * lnRHue1 / 60.0f;   
			else if (lnRHue1 < 180.0f) lnRm11 = lnRm21;
			else if (lnRHue1 < 240.0f) lnRm11 = lnRm11 + (lnRm21 - lnRm11) * (240.0f - lnRHue1) / 60.0f;      

			if      (lnRHue2 <  60.0f) lnRm12 = lnRm12 + (lnRm22 - lnRm12) * lnRHue2 / 60.0f;   
			else if (lnRHue2 < 180.0f) lnRm12 = lnRm22;
			else if (lnRHue2 < 240.0f) lnRm12 = lnRm12 + (lnRm22 - lnRm12) * (240.0f - lnRHue2) / 60.0f;      

			if      (lnRHue3 <  60.0f) lnRm13 = lnRm13 + (lnRm23 - lnRm13) * lnRHue3 / 60.0f;   
			else if (lnRHue3 < 180.0f) lnRm13 = lnRm23;
			else if (lnRHue3 < 240.0f) lnRm13 = lnRm13 + (lnRm23 - lnRm13) * (240.0f - lnRHue3) / 60.0f;      

			lcRed   = (unsigned char)(lnRm11 * 255);
			lcGreen = (unsigned char)(lnRm12 * 255);
			lcBlue  = (unsigned char)(lnRm13 * 255);
		}

        //////////////////////////////////////////////////////////////
			lnPosition[0] = lcBlue;
			lnPosition[1] = lcGreen;
			lnPosition[2] = lcRed;
			lnPosition += 3;
		}
		lnPosition += lnOffset;
	}	
	return 0;
}

////////////////////////////////////////////////////////////////////////////////////
extern "C" __declspec(dllexport) int BitmapDataMakeGrayscale(unsigned int tnBitmapDataWidth, 
														     unsigned int tnBitmapDataHeight, 
														     unsigned int tnBitmapDataScan0,
														     unsigned int tnBitmapDataStride)
{
	unsigned char lcRed, lcGreen, lcBlue;

	int lnStride = tnBitmapDataStride;
	BYTE *lnPosition = (BYTE *)((void *)tnBitmapDataScan0);
	int lnWidth = tnBitmapDataWidth;
	int lnHeight = tnBitmapDataHeight;
	int lnOffset = lnStride - lnWidth*3;    // bytes to skip at end of each row

	for(int lnCounter2=0; lnCounter2 < lnHeight; lnCounter2++) 
	{
		for(int lnCounter1=0; lnCounter1 < lnWidth; ++lnCounter1 )
		{
			lcBlue  = lnPosition[0];
			lcGreen = lnPosition[1];
			lcRed   = lnPosition[2];
         
     
			lnPosition[0] = 0.3333 * (lcRed + lcGreen + lcBlue);
			lnPosition[1] = 0.3333 * (lcRed + lcGreen + lcBlue);
			lnPosition[2] = 0.3333 * (lcRed + lcGreen + lcBlue);
			lnPosition += 3;
		}
		lnPosition += lnOffset;
	}	
	return 0;
}

////////////////////////////////////////////////////////////////////////////////////
extern "C" __declspec(dllexport) int BitmapDataMakeNegative(unsigned int tnBitmapDataWidth, 
														    unsigned int tnBitmapDataHeight, 
														    unsigned int tnBitmapDataScan0,
														    unsigned int tnBitmapDataStride)
{
	unsigned char lcRed, lcGreen, lcBlue;

	int lnStride = tnBitmapDataStride;
	BYTE *lnPosition = (BYTE *)((void *)tnBitmapDataScan0);
	int lnWidth = tnBitmapDataWidth;
	int lnHeight = tnBitmapDataHeight;
	int lnOffset = lnStride - lnWidth*3;    // bytes to skip at end of each row

	for(int lnCounter2=0; lnCounter2 < lnHeight; lnCounter2++) 
	{
		for(int lnCounter1=0; lnCounter1 < lnWidth; ++lnCounter1 )
		{
			lcBlue  = lnPosition[0];
			lcGreen = lnPosition[1];
			lcRed   = lnPosition[2];
         
     
			lnPosition[0] = 255 - lcBlue;
			lnPosition[1] = 255 - lcGreen;
			lnPosition[2] = 255 - lcRed;
			lnPosition += 3;
		}
		lnPosition += lnOffset;
	}	
	return 0;
}
